/********************* Program to Read the Data from MAX158 *************/
#include <stdio.h>
#include <conio.h>
/************************* Constant Value Declarations ******************/
#define Parallel_ADC_Slct	0x02   /* Parallel port Select         		*/
#define Parallel_ADC_DeSlct 0x7d   /* Parallel Port Deselect       		*/
#define Data_Ready			0x08   /* Check for Data Is Ready or Not	*/
#define Data_Parallel_High  0x08   /* To Select Upper 4 Bit Data 		*/
#define Data_Parallel_Low   0x00   /* To Select Lower 4 Bit Data       	*/
/************************* SubRoutine Declarations **********************/
void screen_set_text();            /* Intial   Screen Setup   			*/
void Parallel_Read();              /* Read Data From Paralle Port  		*/
void put_text_data();              /* Put Data on the Screen       		*/
/*********************Global Variable Declarations **********************/
char ch;
int Port_Add,ps,Control_Port,Read_Port,Channel_Port;
int out_data,in_data,Data;
/***********  Selection Data for The Parallel Channel **********/

int P_Ch[3] ={0x02,0x01,0x00};



main() 			/*********** Main Program   Starts Here  ***************/
{
	clrscr();
	Port_Add = 0x378; 				 /* Set the Base Address 		*/
	Control_Port =	Port_Add;        /*  Address of ADC Select Port */
	Read_Port    =  Port_Add + 0x01; /* Address of the read port 	*/
	Channel_Port = Port_Add + 0x02;  /* Address Channel Select port */
	outportb(Control_Port, 0x00);    /* Intialize The Ports 		*/
	outportb(Channel_Port, 0x0F);
	screen_set_text();           	 /* Set The Screen  			*/
	Parallel_Read();             	 /* Read ADC  					*/
}/********************* End of the main  ***********************/

void Parallel_Read()		 /* Read The Data From The Parallel ADC */
{
	 int temp;
	 for(;;)    			/* Start The Scanning of The Channels  */
	 {
	  /* for(ps = 7;ps <= 7; ps++)  */
       for(ps = 0;ps <= 2; ps++)
	  {
		out_data =  P_Ch[ps] | Data_Parallel_High; /* Select Channel*/
		outportb(Channel_Port,out_data);
		Data = 0;
		outportb(Control_Port,Parallel_ADC_Slct);  /* Select ADC */
		do{  			/****  Check for the D_Rdy Line Status ***/
			in_data = inportb(Read_Port);
			in_data = in_data & 0x08;
		} while (in_data != 0);
		Data = inport(Read_Port); 	/* Read the digital data now 	   	*/
		Data = Data & 0xF0;	      	/*  Get Higher Nibble  				*/
		Data = (Data ^ 0x80);
		out_data = out_data |  Data_Parallel_Low; /* Get Lower Nibble 	*/
		outportb(Channel_Port,out_data);
		temp = inport(Read_Port);
		outportb(Control_Port,Parallel_ADC_DeSlct); /* DeSelect ADC 	*/
		/****** Combine two Nibbles for 1 byte of Data *****/
		temp = (temp  & 0xF0 );
		temp = temp ^ 0x80 ;
		temp = temp  >> 4 ;
		Data =  Data | temp;
		put_text_data();		/* Put the data on the screen   */
		if ( kbhit()) 			/* Check for the Quit key Q/q   */
		 {
		   ch= getch();
		   if (ch == 'q' || ch  == 'Q')
		   {       /* set the text background and text color   */
			textbackground(0);textcolor(7);window(1,25,80,25);clrscr();
			exit();
		   }
		 }
	  }
	 }
}

void put_text_data() 		/***  Put text Data on the Screen ***/
{
	int x;
	window(1,1,80,24);gotoxy(20,6);
	printf ("Real time Parallel ADC Data ( Channel : 1 to 3 )");
	/* Print the Channel Number And Data */
	
		gotoxy(16+2*(ps*8),11);printf("%d    ",Data);



}

void screen_set_text() 		/*** Set the Screen in Text Mode Intially ***/
{
	int i,x;
	int t=205;
	window(1,1,80,24);textbackground(3); textcolor(14);clrscr();
	for (i=0;i<=79;i++) printf("%c",t); 	/* For Border on screen  */
	gotoxy(16,1); 	printf("  BATTERY MONITOR");
	gotoxy(22,4);
	printf(" Based On SBSCC Interface   ");
	gotoxy(1,5);
	for (i=0;i<=79;i++) printf("%c",t);  	/*  For Border on screen  */

gotoxy(9,11);printf("Voltage : ");
gotoxy(25,11);printf("Current : ");
gotoxy(41,11);printf("Temperature : ");





	/* Information at the bottom of the screen */
/*	window(1,24,80,24);	textbackground(9); textcolor(14); clrscr();
	printf("Press (Q/q): To quit ");*/
	window(1,25,80,25);
	textbackground(4); textcolor(15); clrscr();
	printf("Developed By: Rsd");
}